#include "cursor.h"

static char dummyCursorData[] = {
 "#define d_width 1\n"
 "#define d_height 1\n"
 "static unsigned char d_bits[] = {0x01};\n"
};

int TkTheme_CursorCreateBlank (Tcl_Interp *interp, TkTheme_Cursor *wPtr) {
 Colormap cmap;

 wPtr->blankCursorPixmap = XCreateBitmapFromData (wPtr->dis, wPtr->xWin, dummyCursorData, 1, 1);

 cmap = DefaultColormap (wPtr->dis, wPtr->screenNum);
        
 if (!XParseColor (wPtr->dis, cmap, "black", &wPtr->blankCursorColor)) {
  Tcl_SetResult (interp, "error parsing color", TCL_STATIC);
  return TCL_ERROR;
 }

 if (!XAllocColor (wPtr->dis, cmap, &wPtr->blankCursorColor)) {
  Tcl_SetResult (interp, "error allocating color", TCL_STATIC);
  return TCL_ERROR;
 }

 wPtr->blankCursor = XCreatePixmapCursor (wPtr->dis, 
  wPtr->blankCursorPixmap, wPtr->blankCursorPixmap, 
  &wPtr->blankCursorColor, &wPtr->blankCursorColor, 0, 0
 );

 return TCL_OK;
}