#include "label.h"

void ThemeLabelCreateClipMask (ThemeLabel *wPtr) {
 GC setGC;
 GC clearGC;
 XGCValues xgcval;

 wPtr->clipMaskPix = XCreatePixmap (wPtr->dis, wPtr->xWin, wPtr->width, wPtr->height, 1);

 xgcval.function = GXclear;
 clearGC = XCreateGC (wPtr->dis, wPtr->clipMaskPix, GCFunction, &xgcval);

 if (NULL == clearGC) {
  Tcl_Panic ("unable to create GC");
 }

 XFillRectangle (wPtr->dis, wPtr->clipMaskPix, clearGC, 0, 0, wPtr->width, wPtr->height); 
 XFreeGC (wPtr->dis, clearGC);

 xgcval.function = GXset;
 xgcval.font = Tk_FontId (wPtr->tkfont);
 setGC = XCreateGC (wPtr->dis, wPtr->clipMaskPix, (GCFunction | GCFont), &xgcval);

 if (NULL == setGC) {
  Tcl_Panic ("unable to create GC");
 }

 Tk_DrawChars (wPtr->dis, 
  wPtr->clipMaskPix, setGC, wPtr->tkfont,
  wPtr->text, strlen (wPtr->text),
  1, ((wPtr->height / 2) + 2 )
 );

 XFree (setGC);
}

