#include "label.h"

void ThemeLabelEvent (ClientData clientData, XEvent *eventPtr) {
 ThemeLabel *wPtr = (ThemeLabel *) clientData;

 if (eventPtr->type == ConfigureNotify) {
  ThemeLabelEventConfigure (wPtr);
  ThemeSendExposeToSelfAndChildren (wPtr->dis, wPtr->xWin);
 } else if (eventPtr->type == DestroyNotify) {
  ThemeLabelCleanupStructure (wPtr);
  return;
 }

 ThemeLabelScheduleDraw (wPtr);
}

void ThemeLabelEventConfigure (ThemeLabel *wPtr) {
 XGCValues xgcval;

 if ((NULL == wPtr->tkfont) || (NULL == wPtr->text)) {
  return;
 }

 wPtr->width = Tk_Width (wPtr->tkwin);
 wPtr->height = Tk_Height (wPtr->tkwin);

 ThemeLabelCreateClipMask (wPtr);

 xgcval.graphics_exposures = 0;
 xgcval.font = Tk_FontId (wPtr->tkfont);
 xgcval.clip_mask = wPtr->clipMaskPix;
 xgcval.clip_x_origin = 1;
 xgcval.clip_y_origin = 1;

 /*TODO make it use the GCForeground we want*/
 wPtr->copyGC = XCreateGC (wPtr->dis, wPtr->xWin, 
  (GCFont | GCClipMask | GCGraphicsExposures | GCClipYOrigin ),
  &xgcval
 );

 wPtr->pix = XCreatePixmap (wPtr->dis, wPtr->xWin, wPtr->width, wPtr->height, wPtr->depth);
 
 XFillRectangle (wPtr->dis, wPtr->pix, wPtr->copyGC, 
  0, 0, 
  wPtr->width, wPtr->height
 );
}

 
